<?php
/**
 * Geocode class file.
 * 
 * @author Deepak Pradhan <deepak.pradhan@IncisiveSystem.com>
 * @link http://gemisoft.com
 * @version 1.0
 */
class Geocode extends CApplicationComponent {
	//Format = address, city, statce-code, zip
	public $address = null; 

	// URL for Google Maps API 
	public $url = 'http://maps.google.com/maps/geo?&output=xml&key=';
	
	// This will key obatined from http://code.google.com/apis/maps/signup.html
	public $key = null;
	
	//The final API URL
	public $api = '';
	
    public function init() {


	}

	public function getGeocode($address) {
        // Replace all spaces, tabs and newlines, the urlencode
		$this->address = urlencode(preg_replace('/\s\s+/', ' ',$address));
        
		// Construct the final API URL
		$this->api = $this->url . $this->key . '&q=' . $this->address;

		// Retrieve the XML
		$responseXML = file_get_contents($this->api);
		
		// Convert XML to Object
		$oXML = new SimpleXMLElement($responseXML);   
		
		// Parse the coordinate string
		list($lng, $lat, $altitude) = explode(",", $oXML->Response->Placemark->Point->coordinates);

        // Make data object to return
		$data = new stdClass;
		if ($lat):
			$data->latitude  = $lat;
			$data->longitude = $lng;
		endif;

		return $data;
	}
}